/*
 * transmitt1.asm
 *
 *  Created: 04.10.2012 15:20:25
 *   Author: Admin
 */ 


 
.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	Temp6=R22
.def	Temp7=R23
.def	Temp8=R24
.def	Temp9=R25


.dseg			;

key_buff: .byte 5	;  5   


;******************************************************************************

.EQU ImpLen=0xCE4 			;  
.EQU OneLen=0xCE4 			;    
.EQU NulLen=0x19C8			;    

;******************************************************************************

.cseg

.org 0


rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

.org   OC1Aaddr				; (=0x0004) Timer/Counter1 Compare Match A

rjmp OCR1A_COMP

.org INT_VECTORS_SIZE


;******************************************************************************
;
;******************************************************************************

reset:					;  

	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00001111		;   "" (0-, 1-)
	out DDRB,Temp			; 0000000 - ""   (PB3- 15 )
					; 0000 - ""    
					; 00000 - ""         "0" ??????????????????
												 
	ldi Temp,0b00001111		;   "D" (0-, 1-)
	out DDRD,Temp 			; 0000 -    


	ldi Temp,0b00000000		;    _0 ????????????????????????????????????????????????
	out portB,Temp	
					
	ldi Temp,0b00000000		;    = CK 0
	out TCCR1B,Temp			;  !!!

	sei				;   
        



;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:

	rcall keyboardread		;    

	rcall certain_buttons_keyboard	;    
	
	rjmp Main_cicle			; 



;*******************************************************************************
;        
;*******************************************************************************

keyboardread:				;  -  

          
	ldi Temp,5			;    = 
         
	ldi Temp1,0b00000001		;  

          				;     (key_buff)       X

	ldi XL,	low(key_buff)		;   
	ldi XH,	high(key_buff)		;   

keyboardread_loop:			;  

	out PortD,Temp1			;    ""  "Temp1"    
	in Temp2,PinB			;   
         
	st X+,Temp2			;      , 
 					;     "X"    1


	lsl Temp1			;       1
 					;  

	dec temp			;  
	brne keyboardread_loop		;    ,  

	ret				;    

       
;******************************************************************************************
;    
;******************************************************************************************

certain_buttons_keyboard:
		

	ldi temp1,5			;    	

	                  		;    (key_buff)       "Z"
	ldi ZL,low (key_buff)		;   
	ldi ZH,high(key_buff)		;    


Certain_button:

	ld Temp,Z+			;            "Z", 
					;           


	cpi Temp,0b00000000		; ,      ?
	brne inform			;       "inform"


	dec temp1			;  
	brne Certain_button		;    ,  

metka:

	ret				;    



;***********************************************************************************************
;        "" 
;***********************************************************************************************

inform:					;    


	;+++++++++++++++++++++++++++++++++++   OC1A=0 

	ldi R16,(1<<COM1A1)|(0<<COM1A0)	; (    "0"      B,    OC1A)
	out TCCR1A,R16


	ldi R16,(1<<FOC1A)		;     OC1A  OC1B!!!
	out TCCR1C,R16 
	;+++++++++++++++++++++++++++++++++++
					

	ldi Temp,(1<<COM1A0)		;   "OC1A"   (PB3- 15 )
	out TCCR1A,Temp			; *1


	LDI R19,2			;     ( 0x200  )
	OUT OCR1AH,R19			;      
	LDI R19,0   
	OUT OCR1AL,R19       

	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp

	ldi Temp,(1<<wgm12)|(1<<cs10)	;   "CTC" (  *1) 
	out TCCR1B,Temp			;     = CK 1:1 
					;   !!!

	ldi Temp,(1<<OCIE1A)		;    
	out TIMSK,Temp
	

	ldi R22, 0			;  

loop_wait_transmitt:			;    

	cpi R22 , 7
	brne loop_wait_transmitt

	ldi temp1,0			;  "temp1",          ???????????????????

	ret				;      


;*******************************************************************************
; 
;*******************************************************************************

OCR1A_COMP:
					;   R22 - 0
					;       

					;    




	in temp,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp


	CPI R22, 1
	BREQ transmitt_byte		;   

	CPI R22, 2
	BREQ transmitt_bite_imp		;      

	CPI R22, 3
	BREQ transmitt_bite_pause	;      

	CPI R22, 4
	BREQ transmitt_imp_chetn	;     

	CPI R22, 5
	BREQ transmitt_pausa_chetn	;     

	CPI R22, 6
	BREQ transmitt_complete		;  ,  


;****************************************************************************************************************

					;  , ( R22=0)



	ldi R21,0			;       ()

	ldi yl,low(key_buff)		;          "Y"
	ldi yh,high(key_buff)

	ldi R17,5			;    


transmitt_byte:				;    -  

 	ld temp,y+			;    ,      "Y" 

	ldi r18,8			;      






transmitt_bite_imp:			;      






	LDI R19 ,high(ImpLen)		;    
	OUT OCR1AH, R19			;      
	LDI R19,low(ImpLen)   
	OUT OCR1AL ,R19       

	LDI  R22, 3			;     




int_reti:				

	pop temp			;  "SREG" ////////////////////////////////////////////////////////////
	out SREG, temp

	RETI				;    


;**********************************************************************************************************************

transmitt_bite_pause:			;      

					;     


	LDI XL,low(Nullen)		;    
	LDI XH,high(Nullen)

	ROL temp			;    (  )
	BRCC send_nullen		;  ""=0    

	
	LDI XL,low(onelen)		;    
	LDI XH,high(onelen)

	INC R21				;   -    () 

send_nullen:

	OUT OCR1AH,XH			;  
	OUT OCR1AH,XL         
               
	LDI R22,2			;      

	dec R18				;     
	brne int_reti			;       -    

	LDI R22,1			;      

	dec R17				;     
	brne int_reti			;        -    
                   
	LDI R22,4			;       

	RJMP int_reti			;   

;*********************************************************************************************************************                   


transmitt_imp_chetn:			;    





	
	LDI R19 ,high(ImpLen)		;    
	OUT OCR1AH, R19			;      
	LDI R19,low(ImpLen)   
	OUT OCR1AL,R19       


	LDI R22,5			;       

	rjmp int_reti			;   

;**********************************************************************************************************************


transmitt_pausa_chetn:			;    

					;       







	LDI XL,low(Nullen)		;     
	LDI XH,high(Nullen)

	COM R21				;  

	ROR R21				;   

	BRCC send_chetn 		;  ""=0    

	LDI XL,low(onelen)		;     
	LDI XH,high(onelen)

send_chetn:

	OUT OCR1AH,XH			;  
	OUT OCR1AH,XL         

	LDI R22,6			; R22=6   
	rjmp int_reti			;   

;*************************************************************************************************************************

transmitt_complete:			;     





	ldi Temp,0b00000000		;    = CK 0  
	out TCCR1B,Temp			;  !!!


	ldi Temp,0b00000000		;    _0 ????????????????????????????????????????????????
	out portB,Temp	
	
	LDI R22, 7			;   
	rjmp int_reti			;   	

;*************************************************************************************************************************
